#ifndef MPLAYERMEDIAIDENTIFIER_H
#define MPLAYERMEDIAIDENTIFIER_H

#include "mediaidentifier.h"
#include "mplayerconfig.h"

class MPlayerMediaIdentifier : public QObject, public AbstractMediaIdentifier
{
    Q_OBJECT
public:
    MPlayerMediaIdentifier(MPlayerConfiguration &config);
    virtual ~MPlayerMediaIdentifier();

    /* AbstractMediaIdentifier */
    virtual QString internalClassName() const { return QString("MPlayer"); }
    virtual QString friendlyDisplayName() const { return QString("MPlayer media scanner"); }

    virtual bool identify(Media *media, const MediaLocation &location);

private slots:
    void parseLines();
    void killIdentifyProcessTimerTimedOut();

private:
    MPlayerConfiguration &config_;
    Media *media_;
    bool fileScanningFinished_;
    bool fileWasIdentified_;
    QProcess *identifyProcess_;
    QTimer killIdentifyProcessTimer_;
    QString tempLine_;

    void cleanUpIdentifyProcess();
    void sendCommand(const QString &command);
};

#endif // MPLAYERMEDIAIDENTIFIER_H
